use std::collections::HashMap;

use anyhow::Result;

// This is just a current implementation of the outputs
use comfy_table::Table;
use url::Url;

use crypto_utils::chacha::decrypt;
use crypto_utils::hash::prf;
use crypto_utils::keys::load_from_file;

pub fn search(phrase: String, address: String) -> Result<()> {
    let enc_key = load_from_file("enc.key")?;
    let prf_key = load_from_file("prf.key")?;
    let scrambled = prf(&prf_key, phrase)?;
    let mut burl = Url::parse(&address)?;
    burl.set_path(&format!("key/{}", scrambled));
    let resp = reqwest::blocking::get(burl)?.json::<HashMap<String, String>>()?;
    let mut table = Table::new();
    for (_, ciphertext) in resp.iter() {
        let decrypted = decrypt(&enc_key, ciphertext.to_string())?;
        table.add_row(decrypted.split(','));
    }
    println!("{table}");
    Ok(())
}
